diff -pruN 2:2.9-1/debian/changelog 2:2.9-1ubuntu4/debian/changelog
--- 2:2.9-1/debian/changelog	2019-08-08 13:59:02.000000000 +0000
+++ 2:2.9-1ubuntu4/debian/changelog	2020-04-15 08:08:07.000000000 +0000
@@ -1,3 +1,41 @@
+wpa (2:2.9-1ubuntu4) focal; urgency=medium
+
+  * debian/patches/git_realtek_macrand.patch:
+    - backport an upstream patch to fix issues with some realtek cards
+      when MAC address randomization is enabled (lp: #1867908)
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 15 Apr 2020 10:08:07 +0200
+
+wpa (2:2.9-1ubuntu3) focal; urgency=medium
+
+  * No-change rebuild for libgcc-s1 package name change.
+
+ -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 17:03:22 +0100
+
+wpa (2:2.9-1ubuntu2) eoan; urgency=medium
+
+   * SECURITY UPDATE: Incorrect indication of disconnection in certain
+     situations
+     - debian/patches/CVE-2019-16275.patch: silently ignore management
+       frame from unexpected source address in src/ap/drv_callbacks.c,
+       src/ap/ieee882_11.c.
+     - CVE-2019-16275
+
+ -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 17 Sep 2019 08:54:07 -0300
+
+wpa (2:2.9-1ubuntu1) eoan; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/patches/wpa_service_ignore-on-isolate.patch: add
+      IgnoreOnIsolate=yes so that when switching "runlevels" in oem-config
+      will not kill off wpa and cause wireless to be unavailable on first
+      boot.
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+  * Dropped CVE-2019-13377 patches, part of 2.9 release
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Wed, 21 Aug 2019 14:58:29 +0200
+
 wpa (2:2.9-1) unstable; urgency=high
 
   * New upstream release (Closes: #934180):
@@ -30,6 +68,45 @@ wpa (2:2.8-3) unstable; urgency=medium
 
  -- Andrej Shadura <andrewsh@debian.org>  Thu, 11 Jul 2019 23:19:03 +0200
 
+wpa (2:2.8-2ubuntu2) eoan; urgency=medium
+
+  * SECURITY UPDATE: SAE/EAP-pwd side-channel attack w/Brainpool curves
+    - debian/patches/CVE-2019-13377-1.patch: use const_time_memcmp() for
+      pwd_value >= prime comparison in src/common/sae.c.
+    - debian/patches/CVE-2019-13377-2.patch: use const_time_memcmp() for
+      pwd_value >= prime comparison in src/eap_common/eap_pwd_common.c.
+    - debian/patches/CVE-2019-13377-3.patch: use BN_bn2binpad() or
+      BN_bn2bin_padded() if available in src/crypto/crypto_openssl.c.
+    - debian/patches/CVE-2019-13377-4.patch: run through prf result
+      processing even if it >= prime in src/common/sae.c.
+    - debian/patches/CVE-2019-13377-5.patch: run through prf result
+      processing even if it >= prime in src/eap_common/eap_pwd_common.c.
+    - debian/patches/CVE-2019-13377-6.patch: disable use of groups using
+      Brainpool curves in src/common/sae.c,
+      src/eap_common/eap_pwd_common.c.
+    - CVE-2019-13377
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 13 Aug 2019 13:32:28 -0400
+
+wpa (2:2.8-2ubuntu1) eoan; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/patches/wpa_service_ignore-on-isolate.patch: add
+      IgnoreOnIsolate=yes so that when switching "runlevels" in oem-config
+      will not kill off wpa and cause wireless to be unavailable on first
+      boot.
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+  * Dropped changes, upstream:
+    - debian/patches/CVE-2019-11555-1.patch: fix reassembly buffer handling
+      in src/eap_server/eap_server_pwd.c.
+    - debian/patches/CVE-2019-11555-2.patch: fix reassembly buffer handling
+      in src/eap_peer/eap_pwd.c.
+    - debian/patches/VU-871675/*.patch: backported upstream patches.
+  * Remove android-headers build-depends
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Wed, 08 May 2019 11:57:47 +0200
+
 wpa (2:2.8-2) experimental; urgency=medium
 
   * Delete patches applied upstream.
@@ -192,6 +269,54 @@ wpa (2:2.7~git20180504+60a5737-1) experi
 
  -- Andrej Shadura <andrewsh@debian.org>  Mon, 07 May 2018 19:57:47 +0200
 
+wpa (2:2.6-21ubuntu4) eoan; urgency=medium
+
+  * SECURITY UPDATE: EAP-pwd DoS via unexpected fragment
+    - debian/patches/CVE-2019-11555-1.patch: fix reassembly buffer handling
+      in src/eap_server/eap_server_pwd.c.
+    - debian/patches/CVE-2019-11555-2.patch: fix reassembly buffer handling
+      in src/eap_peer/eap_pwd.c.
+    - CVE-2019-11555
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 01 May 2019 09:52:58 -0400
+
+wpa (2:2.6-21ubuntu3) disco; urgency=medium
+
+  * SECURITY UPDATE: Multiple security issues
+    - debian/patches/VU-871675/*.patch: backported upstream patches.
+    - CVE-2019-9495
+    - CVE-2019-9497
+    - CVE-2019-9498
+    - CVE-2019-9499
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 10 Apr 2019 12:54:21 -0400
+
+wpa (2:2.6-21ubuntu2) disco; urgency=medium
+
+  * No-change rebuild for readline soname change.
+
+ -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Jan 2019 20:07:20 +0000
+
+wpa (2:2.6-21ubuntu1) disco; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/patches/wpa_service_ignore-on-isolate.patch: add
+      IgnoreOnIsolate=yes so that when switching "runlevels" in oem-config
+      will not kill off wpa and cause wireless to be unavailable on first
+      boot.
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+  * Dropped Android integration (LP: #1734568):
+    - debian/patches/android_hal_fw_path_change.patch: add a DBus method
+      for requesting a firmware change when working with the Android HAL;
+      this is used to set a device in P2P or AP mode; conditional to
+      CONFIG_ANDROID_HAL being enabled.
+    - debian/config/wpasupplicant/linux: enable CONFIG_ANDROID_HAL.
+    - debian/control: Build-Depends on android-headers to get the required
+      wifi headers for the HAL support.
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 07 Jan 2019 08:28:15 +0100
+
 wpa (2:2.6-21) unstable; urgency=medium
 
   * Fix a typo in the patch.
@@ -217,6 +342,25 @@ wpa (2:2.6-19) unstable; urgency=medium
 
  -- Andrej Shadura <andrewsh@debian.org>  Sat, 15 Dec 2018 15:21:08 +0100
 
+wpa (2:2.6-18ubuntu1) cosmic; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/patches/wpa_service_ignore-on-isolate.patch: add
+      IgnoreOnIsolate=yes so that when switching "runlevels" in oem-config
+      will not kill off wpa and cause wireless to be unavailable on first
+      boot.
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+    - debian/patches/android_hal_fw_path_change.patch: add a DBus method
+      for requesting a firmware change when working with the Android HAL;
+      this is used to set a device in P2P or AP mode; conditional to
+      CONFIG_ANDROID_HAL being enabled.
+    - debian/config/wpasupplicant/linux: enable CONFIG_ANDROID_HAL.
+    - debian/control: Build-Depends on android-headers to get the required
+      wifi headers for the HAL support.
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 16 Aug 2018 11:22:10 +0200
+
 wpa (2:2.6-18) unstable; urgency=high
 
   * Fix NL80211_ATTR_SMPS_MODE encoding (Closes: #903952)
@@ -234,6 +378,29 @@ wpa (2:2.6-17) unstable; urgency=medium
 
  -- Andrej Shadura <andrewsh@debian.org>  Fri, 08 Jun 2018 14:30:54 +0200
 
+wpa (2:2.6-16ubuntu1) cosmic; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/patches/wpa_service_ignore-on-isolate.patch: add
+      IgnoreOnIsolate=yes so that when switching "runlevels" in oem-config
+      will not kill off wpa and cause wireless to be unavailable on first
+      boot.
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+    - debian/patches/android_hal_fw_path_change.patch: add a DBus method
+      for requesting a firmware change when working with the Android HAL;
+      this is used to set a device in P2P or AP mode; conditional to
+      CONFIG_ANDROID_HAL being enabled.
+    - debian/config/wpasupplicant/linux: enable CONFIG_ANDROID_HAL.
+    - debian/control: Build-Depends on android-headers to get the required
+      wifi headers for the HAL support.
+  * Changes merged in Debian:
+    - debian/patches/dbus-available-sta.patch: Make the list of connected
+      stations available on DBus for hotspot mode; along with some of the
+      station properties, such as rx/tx packets, bytes, capabilities, etc.
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 28 May 2018 14:55:21 +0200
+
 wpa (2:2.6-16) unstable; urgency=medium
 
   * Fix README.Debian: MyNetWork, not NETBEER (Closes: #791333).
@@ -246,6 +413,36 @@ wpa (2:2.6-16) unstable; urgency=medium
 
  -- Andrej Shadura <andrewsh@debian.org>  Mon, 07 May 2018 15:32:41 +0200
 
+wpa (2:2.6-15ubuntu2) bionic; urgency=high
+
+  * No change rebuild against openssl1.1.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:55:53 +0000
+
+wpa (2:2.6-15ubuntu1) bionic; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - debian/patches/wpa_service_ignore-on-isolate.patch: add
+      IgnoreOnIsolate=yes so that when switching "runlevels" in oem-config
+      will not kill off wpa and cause wireless to be unavailable on first
+      boot.
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+    - debian/patches/android_hal_fw_path_change.patch: add a DBus method
+      for requesting a firmware change when working with the Android HAL;
+      this is used to set a device in P2P or AP mode; conditional to
+      CONFIG_ANDROID_HAL being enabled.
+    - debian/config/wpasupplicant/linux: enable CONFIG_ANDROID_HAL.
+    - debian/control: Build-Depends on android-headers to get the required
+      wifi headers for the HAL support.
+    - debian/patches/dbus-available-sta.patch: Make the list of connected
+      stations available on DBus for hotspot mode; along with some of the
+      station properties, such as rx/tx packets, bytes, capabilities, etc.
+  * Updated debian/patches/dbus-available-sta.patch for new getter API
+    and refreshed other patches.
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Jan 2018 19:47:17 +0100
+
 wpa (2:2.6-15) unstable; urgency=medium
 
   * Update debian/control:
@@ -366,6 +563,28 @@ wpa (2:2.6-4) experimental; urgency=medi
 
  -- Andrew Shadura <andrewsh@debian.org>  Fri, 24 Feb 2017 16:45:48 +0100
 
+wpa (2:2.4-1.1ubuntu1) bionic; urgency=medium
+
+  * Merge with Debian unstable; remaining changes:
+    - debian/patches/wpa_service_ignore-on-isolate.patch: add
+      IgnoreOnIsolate=yes so that when switching "runlevels" in oem-config
+      will not kill off wpa and cause wireless to be unavailable on first
+      boot.
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+    - debian/patches/android_hal_fw_path_change.patch: add a DBus method
+      for requesting a firmware change when working with the Android HAL;
+      this is used to set a device in P2P or AP mode; conditional to
+      CONFIG_ANDROID_HAL being enabled.
+    - debian/config/wpasupplicant/linux: enable CONFIG_ANDROID_HAL.
+    - debian/control: Build-Depends on android-headers to get the required
+      wifi headers for the HAL support.
+    - debian/patches/dbus-available-sta.patch: Make the list of connected
+      stations available on DBus for hotspot mode; along with some of the
+      station properties, such as rx/tx packets, bytes, capabilities, etc.
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 10 Nov 2017 08:20:13 -0500
+
 wpa (2:2.4-1.1) unstable; urgency=high
 
   * Non-maintainer upload by the Security Team.
@@ -644,6 +863,131 @@ wpa (2.3-2.1) unstable; urgency=medium
 
  -- Steinar H. Gunderson <sesse@debian.org>  Sun, 30 Aug 2015 14:47:56 +0200
 
+wpa (2.4-0ubuntu10) artful; urgency=medium
+
+  * SECURITY UPDATE: Multiple issues in WPA protocol
+    - debian/patches/2017-1/*.patch: Add patches from Debian stretch
+    - CVE-2017-13077, CVE-2017-13078, CVE-2017-13079, CVE-2017-13080,
+      CVE-2017-13081, CVE-2017-13082, CVE-2017-13086, CVE-2017-13087,
+      CVE-2017-13088
+  * SECURITY UPDATE: Denial of service issues
+    - debian/patches/2016-1/*.patch: Add patches from Debian stretch
+    - CVE-2016-4476
+    - CVE-2016-4477
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 16 Oct 2017 07:41:21 -0400
+
+wpa (2.4-0ubuntu9) zesty; urgency=medium
+
+  * debian/patches/wpa_service_ignore-on-isolate.patch: add IgnoreOnIsolate=yes
+    so that when switching "runlevels" in oem-config will not kill off wpa
+    and cause wireless to be unavailable on first boot. (LP: #1576024)
+
+ -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 13 Mar 2017 13:46:12 -0400
+
+wpa (2.4-0ubuntu8) yakkety; urgency=medium
+
+  * No-change rebuild for readline soname change.
+
+ -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Sep 2016 12:12:22 +0000
+
+wpa (2.4-0ubuntu7) yakkety; urgency=medium
+
+  * debian/ifupdown/functions.sh: Fix handling for "wpa-roam". Call ifquery
+    instead of directly parsing /run/*/ifstate files to work with current
+    ifupdown. (Closes: #545766, LP: #1545363)
+
+ -- Paul Donohue <ubuntu@PaulSD.com>  Fri, 01 Jul 2016 09:16:21 +0200
+
+wpa (2.4-0ubuntu6) xenial; urgency=medium
+
+  * debian/patches/wpasupplicant_band_selection_aa517ae2.patch: add the last 
+    missing 5 GHz band selection related cherry-pick from Debian that was not 
+    included in wpa 2.4 (LP: #1517040)
+
+ -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Tue, 19 Jan 2016 12:36:00 +0200
+
+wpa (2.4-0ubuntu5) xenial; urgency=medium
+
+  * SECURITY UPDATE: unauthorized WNM Sleep Mode GTK control
+    - debian/patches/CVE-2015-5310.patch: Ignore Key Data in WNM Sleep Mode
+      Response frame if no PMF in use in wpa_supplicant/wnm_sta.c.
+    - CVE-2015-5310
+  * SECURITY UPDATE: EAP-pwd missing last fragment length validation
+    - debian/patches/CVE-2015-5315-1.patch: Fix last fragment length
+      validation in src/eap_peer/eap_pwd.c.
+    - debian/patches/CVE-2015-5315-2.patch: Fix last fragment length
+      validation in src/eap_server/eap_server_pwd.c.
+    - CVE-2015-5315
+  * SECURITY UPDATE: EAP-pwd peer error path failure on unexpected Confirm
+    message
+    - debian/patches/CVE-2015-5316.patch: fix error path in
+      src/eap_peer/eap_pwd.c.
+    - CVE-2015-5316
+  * SECURITY UPDATE: denial of service in NDEF record parser
+    - debian/patches/CVE-2015-8041.patch: validate payload lengths in
+      src/wps/ndef.c.
+    - CVE-2015-8041
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 10 Nov 2015 13:38:25 -0500
+
+wpa (2.4-0ubuntu4) xenial; urgency=medium
+
+  * Add debian/system-sleep/wpasupplicant: Call wpa_cli suspend/resume
+    before/after suspend, like the pm-utils hook. In some cases this brings
+    back missing Wifi connection after resuming. (LP: #1422143)
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 26 Oct 2015 14:24:30 +0100
+
+wpa (2.4-0ubuntu3) wily; urgency=medium
+
+  * debian/patches/dbus-fix-operations-for-p2p-mgmt.patch: fix operations
+    when P2P management interface is used (LP: #1482439)
+
+ -- Ricardo Salveti de Araujo <rsalveti@rsalveti.net>  Wed, 07 Oct 2015 10:21:39 -0300
+
+wpa (2.4-0ubuntu2) wily; urgency=medium
+
+  * debian/config/wpasupplicant/linux:
+    - Reduce the delta to Debian by removing the double setting of CONFIG_AP
+      and CONFIG_P2P. The only actual delta is CONFIG_ANDROID_HAL.
+
+ -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 03 Aug 2015 22:03:51 +0300
+
+wpa (2.4-0ubuntu1) wily; urgency=medium
+
+  * New upstream release.
+  * Merge with Debian unstable; remaining changes:
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+    - debian/patches/android_hal_fw_path_change.patch: add a DBus method for
+      requesting a firmware change when working with the Android HAL; this is
+      used to set a device in P2P or AP mode; conditional to CONFIG_ANDROID_HAL
+      being enabled.
+    - debian/config/wpasupplicant/linux: enable CONFIG_ANDROID_HAL.
+    - debian/control: Build-Depends on android-headers to get the required wifi
+      headers for the HAL support.
+    - debian/patches/dbus-available-sta.patch: Make the list of connected
+      stations available on DBus for hotspot mode; along with some of the
+      station properties, such as rx/tx packets, bytes, capabilities, etc.
+    - debian/patches/CVE-2015-4141.patch: check chunk size: src/wps/httpread.c
+      - CVE-2015-4141
+    - debian/patches/CVE-2015-4142.patch: check length in src/ap/wmm.c.
+      - CVE-2015-4142
+    - debian/patches/CVE-2015-4143-4146.patch: check lengths in
+        src/eap_peer/eap_pwd.c, src/eap_server/eap_server_pwd.c.
+      - CVE-2015-4143, CVE-2015-4144, CVE-2015-4145, CVE-2015-4146
+    - debian/config/wpasupplicant/linux:
+      - Enable CONFIG_AP_MODE (AP mode support) (LP: #1209511).
+      - Enable CONFIG_P2P (Wi-Fi Direct support).
+  * debian/patches/wpa_supplicant-MACsec-fix-build-failure-for-IEEE8021.patch,
+    debian/patches/include-ieee802_11_common.c-in-wpa_supplicant-build-.patch,
+    d/p/hostapd_fix-hostapd-operation-without-hw_mode-driver-data.patch:
+    dropped patches included upstream.
+  * Refreshed all patches.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 27 Jul 2015 17:29:24 -0400
+
 wpa (2.3-2) unstable; urgency=high
 
   * remove Kel Modderman from Uploaders as per his request, many thanks for
@@ -724,6 +1068,103 @@ wpa (2.2-1) unstable; urgency=medium
 
  -- Stefan Lippers-Hollmann <s.l-h@gmx.de>  Wed, 17 Sep 2014 04:52:36 +0200
 
+wpa (2.1-0ubuntu8) wily; urgency=medium
+
+  * SECURITY UPDATE: memcpy overflow in P2P functionality
+    - debian/patches/CVE-2015-1863.patch: validate SID element length in
+      src/p2p/p2p.c.
+    - CVE-2015-1863
+  * SECURITY UPDATE: denial of service via WPS UPnP
+    - debian/patches/CVE-2015-4141.patch: check chunk size in
+      src/wps/httpread.c.
+    - CVE-2015-4141
+  * SECURITY UPDATE: denial of service via AP mode WMM Action frame
+    - debian/patches/CVE-2015-4142.patch: check length in src/ap/wmm.c.
+    - CVE-2015-4142
+  * SECURITY UPDATE: denial of service via EAP-pwd
+    - debian/patches/CVE-2015-4143-4146.patch: check lengths in
+      src/eap_peer/eap_pwd.c, src/eap_server/eap_server_pwd.c.
+    - CVE-2015-4143
+    - CVE-2015-4144
+    - CVE-2015-4145
+    - CVE-2015-4146
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 15 Jun 2015 10:21:54 -0400
+
+wpa (2.1-0ubuntu7) vivid; urgency=medium
+
+  Cherry-pick from Debian svn:
+  * Add wpasupplicant_fix-systemd-unit-dependencies.patch: Fix systemd unit
+    dependencies for wpasupplicant, it needs to be started before the network
+    target (Closes: 780552, LP: #1431774).
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 27 Mar 2015 14:07:35 +0100
+
+wpa (2.1-0ubuntu6) vivid; urgency=medium
+
+  * debian/patches/dbus-available-sta.patch: Make the list of connected
+    stations available on DBus for hotspot mode; along with some of the
+    station properties, such as rx/tx packets, bytes, capabilities, etc.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Fri, 19 Dec 2014 13:29:30 -0500
+
+wpa (2.1-0ubuntu5) vivid; urgency=medium
+
+  * debian/patches/android_hal_fw_path_change.patch: add a DBus method for
+    requesting a firmware change when working with the Android HAL; this is
+    used to set a device in P2P or AP mode; conditional to CONFIG_ANDROID_HAL
+    being enabled.
+  * debian/config/wpasupplicant/linux: enable CONFIG_ANDROID_HAL.
+  * debian/control: Build-Depends on android-headers to get the required wifi
+    headers for the HAL support.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 08 Dec 2014 21:05:25 -0500
+
+wpa (2.1-0ubuntu4) utopic; urgency=medium
+
+  * SECURITY UPDATE: arbitrary command execution via unsanitized string
+    passed to action scripts by wpa_cli and hostapd_cli
+    - debian/patches/CVE-2014-3686.patch: added os_exec() helper to
+      src/utils/os.h, src/utils/os_unix.c, src/utils/os_win32.c,
+      use instead of system() in wpa_supplicant/wpa_cli.c,
+      hostapd/hostapd_cli.c.
+    - CVE-2014-3686
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 10 Oct 2014 09:15:39 -0400
+
+wpa (2.1-0ubuntu3) utopic; urgency=medium
+
+  * debian/patches/git_update_scan_res_for_apscan_1_068e3877.patch: update
+    scan results when using ap_scan=1; this avoids 4-way handshake failures
+    while roaming. (LP: #1348105)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 22 Sep 2014 18:28:29 +0100
+
+wpa (2.1-0ubuntu2) utopic; urgency=medium
+
+  * No-change rebuild with pkg-create-dbgsym 0.65 so that the full set of
+    debug symbol packages are generated.
+
+ -- Colin Watson <cjwatson@ubuntu.com>  Sat, 26 Jul 2014 22:26:29 +0100
+
+wpa (2.1-0ubuntu1) trusty; urgency=medium
+
+  * New upstream release (LP: #1099755)
+  * debian/get-orig-source: update for new git repository for the current
+    hostap/wpasupplicant versions.
+  * Dropped patches due to being applied upstream and included in the current
+    source tarball:
+    - debian/patches/11_wpa_gui_ftbfs_gcc_4_7.patch
+    - debian/patches/13_human_readable_signal.patch
+    - debian/patches/git_deinit_p2p_context_on_mgmt_remove_ff1f9c8.patch
+    - debian/patches/libnl3-includes.patch
+  * debian/patches/git_accept_client_cert_from_server.patch: revert the commit:
+    "OpenSSL: Do not accept SSL Client certificate for server", which breaks
+    many AAA servers that include both client and server EKUs. Cherry-picked
+    from hostap git commit b62d5b5.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 04 Mar 2014 16:13:24 -0500
+
 wpa (1.1-1) unstable; urgency=medium
 
   * New upstream release:
@@ -792,6 +1233,43 @@ wpa (1.0-3.1) unstable; urgency=low
 
  -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 05 Dec 2013 13:56:15 -0500
 
+wpa (1.0-3ubuntu4) trusty; urgency=low
+
+  * debian/patches/git_deinit_p2p_context_on_mgmt_remove_ff1f9c8.patch:
+    deinitialize the P2P context when the management interface gets removed for
+    whatever reason, such as a suspend/resume cycle. (LP: #1210785)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 18 Nov 2013 20:31:00 -0500
+
+wpa (1.0-3ubuntu3) trusty; urgency=low
+
+  * debian/config/wpasupplicant/linux: enable EAP-FAST (LP: #34982)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Wed, 30 Oct 2013 09:25:39 -0700
+
+wpa (1.0-3ubuntu2) saucy; urgency=low
+
+  * debian/config/wpasupplicant/linux:
+    - Enable CONFIG_AP_MODE (AP mode support) (LP: #1209511).
+    - Enable CONFIG_P2P (Wi-Fi Direct support).
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Thu, 08 Aug 2013 10:20:17 -0400
+
+wpa (1.0-3ubuntu1) raring; urgency=low
+
+  * Merge from Debian unstable. Remaining changes:
+    - Enable CONFIG_IBSS_RSN, so that we can turn back on "secure" adhoc
+      support in NetworkManager using IBSS RSN (WPA2).
+    - debian/wpasupplicant.postinst, debian/hostapd.postinst: Only move
+      sendsigs.omit.d/*.pid if the target isn't the same as the source (as is
+      the case when /lib/init/rw is a symlink to /run)
+    - debian/patches/dbus-activation-cmdline.patch: have wpasupplicant create
+      a pid file in /run/sendsigs.omit.d when activated by DBus.
+    - debian/patches/session-ticket.patch: disable the TLS Session Ticket
+      extension to fix auth with 802.1x PEAP on some hardware.
+
+ -- Logan Rosen <logatronico@gmail.com>  Fri, 30 Nov 2012 11:49:00 -0500
+
 wpa (1.0-3) unstable; urgency=high
 
   * ship forgotten README-P2P.
@@ -804,6 +1282,45 @@ wpa (1.0-3) unstable; urgency=high
 
  -- Stefan Lippers-Hollmann <s.l-h@gmx.de>  Mon, 08 Oct 2012 17:48:04 +0200
 
+wpa (1.0-2ubuntu5) quantal; urgency=low
+
+  * debian/patches/session-ticket.patch: disable the TLS Session Ticket
+    extension to fix auth with 802.1x PEAP on some hardware. (LP: #969343)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Wed, 12 Sep 2012 15:57:50 -0400
+
+wpa (1.0-2ubuntu4) quantal; urgency=low
+
+  * Enable CONFIG_IBSS_RSN, so that we can turn back on "secure" adhoc support
+    in NetworkManager using IBSS RSN (WPA2). (LP: #1046918)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Fri, 07 Sep 2012 15:49:45 -0400
+
+wpa (1.0-2ubuntu3) quantal; urgency=low
+
+  * debian/patches/fix_driver_wext_for_broadcom_wl.patch: Drop the patch, it
+    appears to break at least some scans with some Broadcom devices.
+    (LP: #994739)
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Wed, 01 Aug 2012 12:02:44 -0400
+
+wpa (1.0-2ubuntu2) quantal; urgency=low
+
+  * debian/patches/fix_driver_wext_for_broadcom_wl.patch: Add a workaround for
+    Broadcom wl driver's first failing scan (LP: #994739) 
+
+ -- Pau Oliva Fora (pof) <pau@eslack.org>  Mon, 09 Jul 2012 16:44:32 +0200
+
+wpa (1.0-2ubuntu1) quantal; urgency=low
+
+  * debian/wpasupplicant.postinst, debian/hostapd.postinst: Only move
+    sendsigs.omit.d/*.pid if the target isn't the same as the source (as is
+    the case when /lib/init/rw is a symlink to /run)
+  * debian/patches/dbus-activation-cmdline.patch: have wpasupplicant create
+    a pid file in /run/sendsigs.omit.d when activated by DBus.
+
+ -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Fri, 25 May 2012 14:07:55 -0400
+
 wpa (1.0-2) unstable; urgency=low
 
   * Really enable hardened build flags, thanks Simon Ruderich
@@ -2754,3 +3271,4 @@ wpasupplicant (0.2.4-1) unstable; urgenc
       + support for wireless cards using the madwifi driver
 
  -- Kyle McMartin <kyle@debian.org>  Sun, 5 Sep 2004 13:19:27 -0400
+
diff -pruN 2:2.9-1/debian/control 2:2.9-1ubuntu4/debian/control
--- 2:2.9-1/debian/control	2019-08-08 13:59:02.000000000 +0000
+++ 2:2.9-1ubuntu4/debian/control	2019-08-13 23:12:35.000000000 +0000
@@ -1,5 +1,6 @@
 Source: wpa
-Maintainer: Debian wpasupplicant Maintainers <wpa@packages.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian wpasupplicant Maintainers <wpa@packages.debian.org>
 Uploaders:
  Andrej Shadura <andrewsh@debian.org>
 Section: net
diff -pruN 2:2.9-1/debian/patches/CVE-2019-16275.patch 2:2.9-1ubuntu4/debian/patches/CVE-2019-16275.patch
--- 2:2.9-1/debian/patches/CVE-2019-16275.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2:2.9-1ubuntu4/debian/patches/CVE-2019-16275.patch	2019-09-17 11:54:07.000000000 +0000
@@ -0,0 +1,73 @@
+From 8c07fa9eda13e835f3f968b2e1c9a8be3a851ff9 Mon Sep 17 00:00:00 2001
+From: Jouni Malinen <j@w1.fi>
+Date: Thu, 29 Aug 2019 11:52:04 +0300
+Subject: [PATCH] AP: Silently ignore management frame from unexpected source
+ address
+
+Do not process any received Management frames with unexpected/invalid SA
+so that we do not add any state for unexpected STA addresses or end up
+sending out frames to unexpected destination. This prevents unexpected
+sequences where an unprotected frame might end up causing the AP to send
+out a response to another device and that other device processing the
+unexpected response.
+
+In particular, this prevents some potential denial of service cases
+where the unexpected response frame from the AP might result in a
+connected station dropping its association.
+
+Signed-off-by: Jouni Malinen <j@w1.fi>
+---
+ src/ap/drv_callbacks.c | 13 +++++++++++++
+ src/ap/ieee802_11.c    | 12 ++++++++++++
+ 2 files changed, 25 insertions(+)
+
+diff --git a/src/ap/drv_callbacks.c b/src/ap/drv_callbacks.c
+index 31587685fe3b..34ca379edc3d 100644
+--- a/src/ap/drv_callbacks.c
++++ b/src/ap/drv_callbacks.c
+@@ -131,6 +131,19 @@ int hostapd_notif_assoc(struct hostapd_data *hapd, const u8 *addr,
+ 			   "hostapd_notif_assoc: Skip event with no address");
+ 		return -1;
+ 	}
++
++	if (is_multicast_ether_addr(addr) ||
++	    is_zero_ether_addr(addr) ||
++	    os_memcmp(addr, hapd->own_addr, ETH_ALEN) == 0) {
++		/* Do not process any frames with unexpected/invalid SA so that
++		 * we do not add any state for unexpected STA addresses or end
++		 * up sending out frames to unexpected destination. */
++		wpa_printf(MSG_DEBUG, "%s: Invalid SA=" MACSTR
++			   " in received indication - ignore this indication silently",
++			   __func__, MAC2STR(addr));
++		return 0;
++	}
++
+ 	random_add_randomness(addr, ETH_ALEN);
+ 
+ 	hostapd_logger(hapd, addr, HOSTAPD_MODULE_IEEE80211,
+diff --git a/src/ap/ieee802_11.c b/src/ap/ieee802_11.c
+index c85a28db44b7..e7065372e158 100644
+--- a/src/ap/ieee802_11.c
++++ b/src/ap/ieee802_11.c
+@@ -4626,6 +4626,18 @@ int ieee802_11_mgmt(struct hostapd_data *hapd, const u8 *buf, size_t len,
+ 	fc = le_to_host16(mgmt->frame_control);
+ 	stype = WLAN_FC_GET_STYPE(fc);
+ 
++	if (is_multicast_ether_addr(mgmt->sa) ||
++	    is_zero_ether_addr(mgmt->sa) ||
++	    os_memcmp(mgmt->sa, hapd->own_addr, ETH_ALEN) == 0) {
++		/* Do not process any frames with unexpected/invalid SA so that
++		 * we do not add any state for unexpected STA addresses or end
++		 * up sending out frames to unexpected destination. */
++		wpa_printf(MSG_DEBUG, "MGMT: Invalid SA=" MACSTR
++			   " in received frame - ignore this frame silently",
++			   MAC2STR(mgmt->sa));
++		return 0;
++	}
++
+ 	if (stype == WLAN_FC_STYPE_BEACON) {
+ 		handle_beacon(hapd, mgmt, len, fi);
+ 		return 1;
+-- 
+2.20.1
+
diff -pruN 2:2.9-1/debian/patches/git_realtek_macrand.patch 2:2.9-1ubuntu4/debian/patches/git_realtek_macrand.patch
--- 2:2.9-1/debian/patches/git_realtek_macrand.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2:2.9-1ubuntu4/debian/patches/git_realtek_macrand.patch	2020-04-15 08:08:07.000000000 +0000
@@ -0,0 +1,42 @@
+From 7546c489a95a033c78331915fcdfa0e6fd74d563 Mon Sep 17 00:00:00 2001
+From: Ouden <Ouden.Biz@gmail.com>
+Date: Wed, 18 Mar 2020 17:58:37 +0800
+Subject: nl80211: Fix RTM NEW/DELLINK IFLA_IFNAME copy for maximum ifname
+ length
+
+If the kernel rtm_newlink or rtm_dellink send the maximum length of
+ifname (IFNAMSIZ), the event handlers in
+wpa_driver_nl80211_event_rtm_addlink() and
+wpa_driver_nl80211_event_rtm_dellink() did not copy the IFLA_IFNAME
+value. Because the RTA_PAYLOAD (IFLA_IFNAME) length already includes the
+NULL termination, that equals the IFNAMSIZ.
+
+Fix the condition when IFNAME reach maximum size.
+
+Signed-off-by: Ouden <Ouden.Biz@gmail.com>
+---
+ src/drivers/driver_nl80211.c | 4 ++--
+ 1 file changed, 2 insertions(+), 2 deletions(-)
+
+Index: wpa-2.9/src/drivers/driver_nl80211.c
+===================================================================
+--- wpa-2.9.orig/src/drivers/driver_nl80211.c
++++ wpa-2.9/src/drivers/driver_nl80211.c
+@@ -1065,7 +1065,7 @@ static void wpa_driver_nl80211_event_rtm
+ 	while (RTA_OK(attr, attrlen)) {
+ 		switch (attr->rta_type) {
+ 		case IFLA_IFNAME:
+-			if (RTA_PAYLOAD(attr) >= IFNAMSIZ)
++			if (RTA_PAYLOAD(attr) > IFNAMSIZ)
+ 				break;
+ 			os_memcpy(ifname, RTA_DATA(attr), RTA_PAYLOAD(attr));
+ 			ifname[RTA_PAYLOAD(attr)] = '\0';
+@@ -1240,7 +1240,7 @@ static void wpa_driver_nl80211_event_rtm
+ 	while (RTA_OK(attr, attrlen)) {
+ 		switch (attr->rta_type) {
+ 		case IFLA_IFNAME:
+-			if (RTA_PAYLOAD(attr) >= IFNAMSIZ)
++			if (RTA_PAYLOAD(attr) > IFNAMSIZ)
+ 				break;
+ 			os_memcpy(ifname, RTA_DATA(attr), RTA_PAYLOAD(attr));
+ 			ifname[RTA_PAYLOAD(attr)] = '\0';
diff -pruN 2:2.9-1/debian/patches/series 2:2.9-1ubuntu4/debian/patches/series
--- 2:2.9-1/debian/patches/series	2019-08-08 13:59:02.000000000 +0000
+++ 2:2.9-1ubuntu4/debian/patches/series	2020-04-15 08:08:07.000000000 +0000
@@ -6,3 +6,8 @@
 networkd-driver-fallback.patch
 wpa_supplicant_fix-dependency-odering-when-invoked-with-dbus.patch
 allow-tlsv1.patch
+# Ubuntu patches
+session-ticket.patch
+wpa_service_ignore-on-isolate.patch
+CVE-2019-16275.patch
+git_realtek_macrand.patch
diff -pruN 2:2.9-1/debian/patches/session-ticket.patch 2:2.9-1ubuntu4/debian/patches/session-ticket.patch
--- 2:2.9-1/debian/patches/session-ticket.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2:2.9-1ubuntu4/debian/patches/session-ticket.patch	2019-08-21 12:55:33.000000000 +0000
@@ -0,0 +1,19 @@
+From: Jeremy Nickurak <jeremy@nickurak.ca>
+Subject: Disable the session ticket TLS extension.
+Bug-ubuntu: https://bugs.launchpad.net/ubuntu/+source/wpasupplicant/+bug/969343
+Bug: http://w1.fi/bugz/show_bug.cgi?id=447
+
+---
+ src/crypto/tls_openssl.c |    1 +
+ 1 file changed, 1 insertion(+)
+
+--- a/src/crypto/tls_openssl.c
++++ b/src/crypto/tls_openssl.c
+@@ -1584,6 +1584,7 @@ struct tls_connection * tls_connection_i
+ #ifdef SSL_OP_NO_COMPRESSION
+ 	options |= SSL_OP_NO_COMPRESSION;
+ #endif /* SSL_OP_NO_COMPRESSION */
++	options |= SSL_OP_NO_TICKET;
+ 	SSL_set_options(conn->ssl, options);
+ #ifdef SSL_OP_ENABLE_MIDDLEBOX_COMPAT
+ 	/* Hopefully there is no need for middlebox compatibility mechanisms
diff -pruN 2:2.9-1/debian/patches/wpa_service_ignore-on-isolate.patch 2:2.9-1ubuntu4/debian/patches/wpa_service_ignore-on-isolate.patch
--- 2:2.9-1/debian/patches/wpa_service_ignore-on-isolate.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2:2.9-1ubuntu4/debian/patches/wpa_service_ignore-on-isolate.patch	2019-05-08 09:51:27.000000000 +0000
@@ -0,0 +1,16 @@
+Updated: 2017-11-10
+
+---
+ wpa_supplicant/systemd/wpa_supplicant.service.in |    2 ++
+ 1 file changed, 2 insertions(+)
+
+--- a/wpa_supplicant/systemd/wpa_supplicant.service.in
++++ b/wpa_supplicant/systemd/wpa_supplicant.service.in
+@@ -3,6 +3,7 @@ Description=WPA supplicant
+ Before=network.target
+ After=dbus.service
+ Wants=network.target
++IgnoreOnIsolate=true
+ 
+ [Service]
+ Type=dbus
